## Script (Python) "getCloud"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Return the proper set of Weblog Entries based on subpath
##

#Get the parent weblog
weblog = context.quills_tool.getParentWeblog(context)

#Get a list of topics, sorted alphabetically
topics = weblog.getCategories()

#Create a list of entries for each topic
nb = []
for topic in topics:
        nb.append(  len(topic) )

#Find the Min and Max number entries
min_nb = min(nb)
max_nb = max(nb)
size_nb = max_nb - min_nb + 0.0

#Create a lists to return tuples containing the topic object
#the relative weight of the topic (hardcoded to a size from 1 to 3
#and the number of entries for that topic, since we already calculated it
#skip topics that have no entries.
result = []
for topic,entries in zip(topics,nb):
        if entries > 1:
                #Normalize the result
                rel = ( (item - min_nb ) / size_nb )
                #Modify range
                rel = (rel * 1.5) + 1
                #Add the result
                result.append( [topic,rel,entries] )
#Done...
return result
