## Script (Python) "getComments"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Provide comment management functionality
##

from Products.CMFCore.utils import getToolByName

portal = getToolByName(context,'portal_url').getPortalObject()
portal_catalog = getToolByName(context,'portal_catalog')
dtool = portal.portal_discussion

def getReplies(dtool, content):
    """recursively collect all replies to the given content object."""
    flat_list = []
    discussion = dtool.getDiscussionFor(content)
    if discussion.hasReplies(content):
        replies = discussion.getReplies()
        for reply in replies:
            flat_list.append(reply)
            flat_list.extend(getReplies(dtool, reply))
    return flat_list


def getComments(portal):
    """Build an (expensive) list of all WeblogEntry comments which can
    then be searched and edited effectively.
    """

    entry_brains = portal_catalog(portal_type=['WeblogEntry'],
                                  path='/'.join(portal.getPhysicalPath()),
                                  sort_on='effective',
                                  sort_order='reverse',
                                  review_state='published')
    
    comment_list = []
    
    for brain in entry_brains:
        entry = brain.getObject()
        if dtool.isDiscussionAllowedFor(entry):
            flat_replies = getReplies(dtool, entry)
            comment_list.extend(flat_replies)

    return comment_list
    

replies = getComments(portal)


return replies
