# CMF imports
from Products.CMFCore.utils import getToolByName

# Standard library imports
from cStringIO import StringIO

# Archetypes imports
from Products.Archetypes.public import listTypes, process_types
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

# Product imports
from Products.fatsyndication.config import PROJECTNAME, GLOBALS, \
    TOOL_ID, TOOL_PORTAL_TYPE
from Products.fatsyndication import permissions as perms


def installTools(self, product, tools, out):
    addTool = self.manage_addProduct[product].manage_addTool
    for tool in tools:
        try:
            addTool(tool)
            out.write("Created tool: %s.\n" % tool)
	except:
	    out.write("Failed creating tool: %s. Already existed?\n" % tool)
    pp = getToolByName(self, 'portal_properties')
    np = pp.navtree_properties
    mtntl = list(np.getProperty('metaTypesNotToList'))
    if TOOL_PORTAL_TYPE not in mtntl:
        mtntl.append(TOOL_PORTAL_TYPE)
        np.manage_changeProperties(metaTypesNotToList=mtntl)

def uninstallTools(self, out):
    self.manage_delObjects(ids=TOOL_ID)
    pp = getToolByName(self, 'portal_properties')
    np = pp.navtree_properties
    mtntl = list(np.getProperty('metaTypesNotToList'))
    if TOOL_PORTAL_TYPE in mtntl:
        mtntl.remove(TOOL_PORTAL_TYPE)
        np.manage_changeProperties(metaTypesNotToList=mtntl)
    out.write("Removed the tool: %s.\n" % TOOL_ID)


def install(self, reinstall=False):
    out = StringIO()

    the_types = listTypes(PROJECTNAME)
    installTypes(self, out, the_types, PROJECTNAME)
    types_as_str = ', '.join( [each['portal_type'] for each in the_types] )
    out.write( 'Installed the portal_types: %s\n' % types_as_str )

    installTools(self, PROJECTNAME, (TOOL_PORTAL_TYPE,), out)
    out.write('Installed the tool: %s\n' % TOOL_ID)

    install_subskin(self, out, GLOBALS)
    #perms.setupPortalSecurity(self, out)

    print >> out, "Successfully installed %s.\n" % PROJECTNAME
    return out.getvalue()

