# Five imports
from Products.Five import BrowserView

# Zope3 imports
from zope.component import getView

# Zope2 imports

# CMF imports
from Products.CMFCore.utils import getToolByName

# Archetypes imports
from Products.Archetypes.config import REFERENCE_CATALOG
from Products.Archetypes.ReferenceEngine import ReferenceException

# Product imports
from Products.fatsyndication.config import TOOL_ID

# basesyndication imports
from Products.basesyndication.interfaces import IFeed


class FeedView(BrowserView):
    """More docstring. Please Zope"""

    def getSyndicationManager(self):
        try:
            syntool = getToolByName(self.context, TOOL_ID)
            return syntool.getSyndicationManagerFor(self.context)
        except (AttributeError, # Raised if the tool is not installed (which is fine)
                ReferenceException):
            # self.context isn't referenceable
            return None

    def getFeed(self):
        if IFeed.providedBy(self):
            return self
        sm = self.getSyndicationManager()
        if sm is not None:
            feed = sm.getDefaultFeed()
        else:
            # Must have an acquisition context in order to play properly with zope
            feed = IFeed(self.context).__of__(self.context)
        return feed

    def atom(self):
        """ """
        feed = self.getFeed()
        view = getView(feed, 'atom.xml', self.request)
        return view()

    def rdf(self):
        """ """
        feed = self.getFeed()
        view = getView(feed, 'feed.rdf', self.request)
        return view()

    def rdf11(self):
        """ """
        feed = self.getFeed()
        view = getView(feed, 'feed11.rdf', self.request)
        return view()        

    def rss(self):
        """ """
        feed = self.getFeed()
        view = getView(feed, 'rss.xml', self.request)
        return view()
