# Archetypes imports
from Products.Archetypes.public import BaseSchema, Schema
from Products.Archetypes.public import StringField, BooleanField, ReferenceField
from Products.Archetypes.public import IntegerField, TextField, LinesField
from Products.Archetypes.public import StringWidget, BooleanWidget, SelectionWidget, LinesWidget, RichWidget
from Products.Archetypes.public import PasswordWidget, IntegerWidget, TextAreaWidget, ReferenceWidget
from Products.Archetypes.Marshall import PrimaryFieldMarshaller

# Product imports
from config import SYNDICATION_MANAGER_RELATION, FEED_SOURCE_RELATION
import permissions as perms

syndication_feed_schema = BaseSchema

syndication_manager_schema = BaseSchema + Schema((

    ReferenceField('content',
                   searchable=0,
                   relationship=SYNDICATION_MANAGER_RELATION,
                   multiValued=0,
                   widget=ReferenceWidget(
                       label='Content Object',
                       description='The portal object that the syndication manager is related to.'),
                  ),
    StringField('defaultFeedId',
                searchable=0,
                vocabulary='getFeedIds',
                widget=SelectionWidget(
                    label='Default Feed Id',
                    description='Id of the feed that is used by default.'),
                ),
    ),
    marshall=PrimaryFieldMarshaller(),
    )


referenced_feed_source_schema = BaseSchema + Schema((

    ReferenceField('source',
                   searchable=0,
                   relationship=FEED_SOURCE_RELATION,
                   multiValued=0,
                   widget=ReferenceWidget(
                       label='Feed Source',
                       description='The portal object that should be used to provide feed entries.'),
                   ),
    ),
    marshall=PrimaryFieldMarshaller(),
    )
