# Standard library imports
import random

# Zope3 imports
from zope.interface import implements

# Zope2 imports
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass

# CMF imports
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.utils import UniqueObject

# Archetypes imports
from Products.Archetypes.config import REFERENCE_CATALOG
from Products.Archetypes.public import BaseBTreeFolder, registerType, BaseFolderSchema

# Product imports
from config import PROJECTNAME, TOOL_ID, TOOL_PORTAL_TYPE, SYNDICATION_MANAGER_PORTAL_TYPE, SYNDICATION_MANAGER_RELATION
import permissions as perms

# basesyndication imports
from Products.basesyndication.interfaces import ISyndicationTool


class SyndicationTool(UniqueObject, BaseBTreeFolder):
    """XXX Fill me in.
    """

    id = TOOL_ID

    schema = BaseFolderSchema
    security = ClassSecurityInfo()
    filter_content_types = 1
    allowed_content_types = [SYNDICATION_MANAGER_PORTAL_TYPE]
    global_allow = 0
    meta_type = portal_type = archetype_name = TOOL_PORTAL_TYPE

    #__implements__ = (UniqueObject.__implements__ + BaseBTreeFolder.__implements__)
    implements(ISyndicationTool)

    def __init__(self):
        BaseBTreeFolder.__init__(self, self.id)

    def getSyndicationManagerFor(self, content):
        """Returns a SyndicationManager, or None.
        """
        reftool = getToolByName(self, REFERENCE_CATALOG)
        sms = reftool.getBackReferences(content, relationship=SYNDICATION_MANAGER_RELATION)
        if sms:
            # There should be only one of these references, but it it's still returned in a sequence.
            return sms[0]

    def returnSyndicationManagerFor(self, content):
        """Guarantees to return a SyndicationManager, even if one doesn't yet exist.
        """
        sm = self.getSyndicationManagerFor(content)
        if sm is None:
            sm = self.addSyndicationManagerFor(content)
        return sm

    def addSyndicationManagerFor(self, content):
        id = self.genId()
        self.invokeFactory(SYNDICATION_MANAGER_PORTAL_TYPE, id=id)
        sm = getattr(self, id)
        sm.setContent( content.UID() )
        sm.reindexObject()
        return sm

    def genId(self):
        while 1:
            id = str( random.randint(0, 99999) )
            if getattr(self, id, None) is None:
                break
        return id

registerType(SyndicationTool, PROJECTNAME)
